class lk_GGKHandler : StaticEventHandler
{
	Actor pendingkill;
	GloryFist pfist;
	IStagger estagger;
	
	Actor ActClone(Actor e)
	{
		Actor act = Actor.Spawn(""..e.getClassName(),e.pos,ALLOW_REPLACE);
		if(act)
		{
			act.vel = e.vel;
			act.bNODAMAGE = true;
			act.SetOrigin(e.pos,false);
			act.master = e;
			act.GiveInventory("kill_doppelganger",1);
		}
		return act;
	}

	virtual void CheckStagger(Actor thing, float dmg)
	{
		// Basically uses the same percent change algo as pokemon red/blue but with = comparison not just <.
		bool randstagger = ( (100-sv_glorystunchance)-random[StaggerRNG](0,100) <= 0 );
		// Check stagger health
		if( thing.health > 0 && (thing.health <= thing.SpawnHealth()*sv_staggerhealth) && randstagger ) 
		{
			thing.A_GiveInventory("IStagger",1);
		}	
	}

	override void WorldThingDamaged(WorldEvent e)
	{
		if(e.Thing)
		{	
			//ScaleDamage(e);
			if( e.Thing.bISMONSTER && !e.Thing.FindInventory("IStagger") ) CheckStagger(e.Thing,e.Damage);
		}	
	}

	override void WorldTick()
	{
		PlayerPawn plr = PlayerPawn(players[consoleplayer].mo);
		if(!plr) return;
		
		// Mainly used to keep readability clean.
		bool dokill = pendingkill && pendingkill.health >  0;
		bool isdead = pendingkill && pendingkill.health <= 0;
		
		// Grab items.
		pfist = GloryFist(plr.FindInventory("GloryFist"));
		if(dokill) estagger = IStagger(pendingkill.FindInventory("IStagger"));
		
		// If the player is ready to glory kill, set the target to kill.
		if(pfist && !pfist.ptarget) pfist.ptarget = pendingkill;
			
		// If the target is dead and the player just killed them, remove stagger from corpse.
		if(isdead && pfist) pendingkill.TakeInventory("IStagger",1);
		
		// If the target needs to die and they're close enough, setup glory kill.
		// Reset the enemy stagger timeout.
		if(dokill && plr.Distance3D(pendingkill) <= 64 && !pfist) 
		{	
			plr.A_GiveInventory("GloryFist",1);
			plr.A_SelectWeapon("GloryFist");
		}
	}

	override void NetworkProcess(ConsoleEvent ev)
	{
		/* 
			Check for glory kill button event, find actor with-in range.
			If the actor is staggered, make them our target we need to kill.
			If the actor is out of our punch range, move them to us.
		*/
	
		PlayerPawn plr = PlayerPawn(players[ev.Player].mo);
		if(!plr) return;
		if(plr.FindInventory("Kicking") || plr.FindInventory("ShoulderInv")) return;
		if(pendingkill && pendingkill.health > 0) return;
		
		if(ev.Name == "glory_kill")
		{
			FLineTraceData lt_data;
			plr.LineTrace(plr.angle,sv_glorykillrange,plr.pitch,0,plr.viewheight,0,0,lt_data);
			if(lt_data.HitType == TRACE_HitActor)
			{
				Actor thinghit = lt_data.HitActor;
				let staggered = IStagger(thinghit.FindInventory("IStagger"));
				if(!staggered) return;	
				plr.A_GiveInventory("ShoulderInv",1);
				// Object is viable.
				pendingkill = thinghit;
				pendingkill.GiveInventory("ObjectMover",1);
				// Doomguy is a Jedi now, i guess.
				let omover = ObjectMover(pendingkill.FindInventory("ObjectMover"));
				if(omover) 
				{
					omover.to = plr;
					omover.dist = 64;
				}
			}
		}
	}
}



/*
	|---------------------------------------|
	| Old Damage mod code, didn't work out. |
	|---------------------------------------|
	
	if(e.Thing.health+e.Damage >= e.Thing.SpawnHealth() && e.Thing.SpawnHealth() - e.Damage*sv_outdamagemod > 0) 
	{
		float newhp = (e.Thing.health + e.Damage);
		let newact = ActClone(e.Thing);
		if(newact)
		{
			newact.A_SetHealth(newhp);
			e.Thing.DamageMobj(e.Thing,NULL,(e.Damage*sv_outdamagemod),"ScaledDamage",e.DamageFlags,e.DamageAngle);
		}
	}
	
*/

// Kappa