// Glory kill fist
class GloryFist : Weapon
{	
	Default
	{
		AttackSound "*fist";
	}
	
	Weapon prevWeapon;
	Actor ptarget; 
	int ptics;
	float vbob;
	
	action void A_ResetWeapon()
	{
		PlayerInfo plr = PlayerPawn(self).player;

		if(invoker.ptarget) 
		{
			if(sv_glorykilldrops)
			{
				int drops = ceil((80-plr.health)/3)+1;
				if(drops <= 0) drops = random(1,4);
				for(int i = 0; i < drops; i++)
				{	
					float xoffs = cos(invoker.ptarget.angle)*frandom(-10,10);
					float yoffs = sin(invoker.ptarget.angle)*frandom(-10,10);
					float axoffs = cos(invoker.ptarget.angle)*frandom(-5,5);
					float ayoffs = sin(invoker.ptarget.angle)*frandom(-5,5);
					float arxoffs = cos(invoker.ptarget.angle)*frandom(-15,15);
					float aryoffs = sin(invoker.ptarget.angle)*frandom(-15,15);
					float zoffs = frandom(5,invoker.ptarget.height);
					let hpup = SuperHealthBonus(Spawn("SuperHealthBonus",(invoker.ptarget.pos.x,invoker.ptarget.pos.y,invoker.ptarget.pos.z-zoffs)));
					if(hpup)
					{
						hpup.plr = plr.mo;
						hpup.vel.x = xoffs;
						hpup.vel.y = yoffs;
					}
					let amup = SuperBackpack(Spawn("SuperBackpack",(invoker.ptarget.pos.x,invoker.ptarget.pos.y,invoker.ptarget.pos.z-zoffs)));
					if(amup)
					{
						amup.plr = plr.mo;
						amup.vel.x = axoffs;
						amup.vel.y = ayoffs;
					}
					let armup = SuperArmorBonus(Spawn("SuperArmorBonus",(invoker.ptarget.pos.x,invoker.ptarget.pos.y,invoker.ptarget.pos.z-zoffs)));
					if(armup)
					{
						armup.plr = plr.mo;
						armup.vel.x = arxoffs;
						armup.vel.y = aryoffs;
					}
				}
			}
			invoker.ptarget.tics = invoker.ptics;
		}
		plr.cheats &= ~(CF_TOTALLYFROZEN|CF_NOTARGET|CF_GODMODE|CF_GODMODE2|CF_INSTANTWEAPSWITCH|CF_DOUBLEFIRINGSPEED);
		plr.mo.ViewBob = invoker.vbob;
		
		if(plr) plr.PendingWeapon = invoker.prevWeapon;
		RemoveInventory(invoker); 
		PSprite pweapon = plr.GetPSprite(PSP_WEAPON);
		pweapon.x -= 130;
		//pweapon.y = WEAPONTOP;
		pweapon.ResetInterpolation();
	}
	
	action void A_ToggleFlip()
	{
		PlayerInfo plr = PlayerPawn(self).player;
		PSprite pweapon = plr.GetPSprite(PSP_WEAPON);
		if(pweapon) 
		{
			pweapon.bFlip = !pweapon.bFlip;	
			pweapon.x -= 130 * (pweapon.bFlip*-1);
			pweapon.ResetInterpolation();
		}
	}
	
	override void DoEffect()
	{		
		if(!PlayerPawn(Owner)) 
		{
			super.DoEffect();
			return;
		}
		if(ptarget && ptarget.health >= 0) 
		{
			if(ptarget.tics != -1) 
			{
				ptics = ptarget.tics;
				ptarget.tics = -1;
			}
			PlayerInfo plr = PlayerPawn(Owner).player;
			plr.mo.vel *= 0;
			if(!vbob) vbob = plr.mo.ViewBob;
			plr.mo.ViewBob *= 0;
			plr.cheats |= CF_TOTALLYFROZEN|CF_NOTARGET|CF_GODMODE2|CF_GODMODE|CF_DOUBLEFIRINGSPEED;
		}
		PlayerInfo plr = PlayerPawn(Owner).player;
		if(!prevWeapon && plr.ReadyWeapon) 
		{
			plr.cheats |= CF_INSTANTWEAPSWITCH;
			prevWeapon = plr.ReadyWeapon;
		}
		super.DoEffect();
	}
	
	action void A_GloryPunch(bool kill = false)
	{	
		PlayerInfo plr = PlayerPawn(self).player;
		A_PlaySound("fht1",0);
		A_Quake(5,3,0,10,"");
		A_CustomPunch(1,true,0,"NewBulletPuff",64,0,0,"","none");
		if(invoker.ptarget && kill) invoker.ptarget.A_Die("GloryKill");
		plr.mo.ViewBob *= 1;
	}
	
	action void A_GloryBlade(bool kill = false)
	{	
		PlayerInfo plr = PlayerPawn(self).player;
		A_PlaySound("sword4",0);
		A_Quake(5,3,0,10,"");
		A_CustomPunch(1,true,0,"NewBulletPuff",64,0,0,"","none");
		if(invoker.ptarget && kill) invoker.ptarget.A_Die("GloryKillHead");
		plr.mo.ViewBob *= 1;
	}
	
	action void A_GloryKick(bool kill = false)
	{	
		PlayerInfo plr = PlayerPawn(self).player;
		A_PlaySound("fht1",0);
		A_Quake(5,3,0,10,"");
		A_CustomPunch(1,true,0,"NewBulletPuff",64,0,0,"","none");
		if(invoker.ptarget && kill) invoker.ptarget.A_Die("GloryKill");
		plr.mo.ViewBob *= 1;
	}
	
	States
	{
		Ready:
			PKFS B 1 A_WeaponReady();
		goto Fire;
		Done:
			PKFS B 1 A_ResetWeapon();
		Deselect:
			PKFS B 1 A_Lower(WEAPONBOTTOM);
		Loop;
		Select:
			PKFS B 1 A_Raise(WEAPONTOP);
		Loop;
		Fire:
			TNT1 A 0 A_Jump(64,"AltKill");
			TNT1 A 0 A_Jump(96,"AltKill2");
			TNT1 A 0 A_WeaponOffset(-20,60);
			PKFS LBCD 1;
			PKFS E 2 A_GloryPunch();
			PKFS EE 1 
			{	
				A_WeaponOffset(30/2,-32/2,WOF_ADD | WOF_INTERPOLATE);
				A_SetRoll(roll+1.25,SPF_INTERPOLATE);
			}
			PKFS EEE 1 
			{
				A_WeaponOffset(-30/5,32/5,WOF_ADD | WOF_INTERPOLATE);
				A_SetRoll(roll-1.25,SPF_INTERPOLATE);
			}
			TNT1 A 0 A_WeaponOffset(-20,60);
			PKFS CCB 1;
			TNT1 A 0 A_ToggleFlip();
			PKF2 HGF 1;
			PKF2 E 1 A_GloryPunch(true);
			PKF2 EE 1 
			{	
				A_WeaponOffset(-30/2,-32/2,WOF_ADD | WOF_INTERPOLATE);
				A_SetRoll(roll-1.25,SPF_INTERPOLATE);
			}
			PKF2 EEE 1 
			{
				A_WeaponOffset(30/5,32/5,WOF_ADD | WOF_INTERPOLATE);
				A_SetRoll(roll+1.25,SPF_INTERPOLATE);
			}
			PKF2 FGH 1;
			TNT1 A 0 A_TakeInventory("ShoulderInv",1);
		Goto Done;
		AltKill:
			TNT1 A 0 A_GloryBlade();
			TNT1 A 4;
			KICK ABCD 1;
			KICK E 3;
			KICK FG 1;
			
			TNT1 A 2;
			KIK2 ABCDE 1 A_ZoomFactor(1.2,ZOOM_NOSCALETURNING);
			KIK2 F 3;
			TNT1 A 0 A_GloryKick(true);
			KIK2 GHIJK 1 A_ZoomFactor(0.8,ZOOM_NOSCALETURNING);
			TNT1 A 0 A_TakeInventory("ShoulderInv",1);
			TNT1 A 2 A_ZoomFactor(1.0,ZOOM_NOSCALETURNING);
		Goto Done;	
		AltKill2:
			//TNT1 A 0 A_PlaySound("bkick2",0);
			KIK2 ABCDE 1 A_ZoomFactor(1.2,ZOOM_NOSCALETURNING);
			TNT1 A 0 A_GloryKick();
			KIK2 F 3 A_ZoomFactor(0.8,ZOOM_NOSCALETURNING);
			KIK2 GHIJK 1;
			
			TNT1 A 2 A_ZoomFactor(1.0,ZOOM_NOSCALETURNING);
			TNT1 A 0 A_GloryBlade(True);
			KIC3 ABCDE 1 A_SetPitch(-10,SPF_FORCECLAMP);
			KIC3 FGHI 1;
			TNT1 A 0 A_TakeInventory("ShoulderInv",1);
		Goto Done;		
	}
}