//version 4.0

class LK_RayboxDamageModifier : Inventory
{
	const HEADSHOT_MOD = 2.0;
	const LEGSHOT_MOD = 0.75;
	
	Default
	{
		Inventory.MaxAmount 1;
	}
	
	override void ModifyDamage(int damage, Name damagetype, out int newdamage, bool passive, Actor inflictor, Actor source, int flags)
	{
		if(!passive) return;
		Name OutDamageType = damageType;
		double OutDamage = damage;
		
        // Determine if shooter is a player, if so take into account players
        // view height and if the player is crouching.
        let plr = PlayerPawn(source);
        double hitslope = source.height/2;
        if(plr) hitslope = plr.viewheight*plr.Player.crouchfactor;
       
        // Preform ray cast to determine where the shooter is aiming.
        FLineTraceData lt;
        source.LineTrace(source.angle,2048,source.pitch,0,hitslope,0,0,lt);
        float dmgz = lt.HitLocation.z;
          
		// Saftey check.
		if(!Owner) return;
		
        // Get "head" location from where shooter is aiming.
        float headz    = (Owner.pos.z + Owner.height);
        float head_top =  18;
        float feetz    =  Owner.pos.z;
        float feet_len =  Owner.height/2;
        // Compare ray location with the head hit boundaries
        // Only comparing the Y axis as the actor must've been hit already to
        // get this event to trigger ("WorldThingDamaged")
        if(dmgz <= headz && dmgz >= headz-head_top)
        {
            // Calculate Damage and DamageType for Headshot
            OutDamageType = (damage <= 10) ? "HeadMinor" : "Head";
            OutDamage = damage*HEADSHOT_MOD; 
        }
        else if (dmgz >= feetz && dmgz <= feetz+feet_len)
        {
            OutDamageType = (damage <= 10) ? "MinorLeg" : (damage >= 50 ? "LegDual" : "Leg");
            OutDamage = damage*LEGSHOT_MOD; 
        }
		
		console.printf("Final: %s", OutDamageType);
		newdamage = max(1, ApplyDamageFactors(GetClass(), OutDamageType, OutDamage, OutDamage));
	}
}

class LK_HandleRaycastHitboxes : EventHandler
{
	override void WorldThingSpawned(WorldEvent e)
	{
		if(e.Thing && e.Thing.bSHOOTABLE) e.Thing.GiveInventory("LK_RayboxDamageModifier", 1);
	}
}